exec("./support.cs");
$WHITELIST_DB = "config/server/whitelist/db";
// format:
// BL_ID	DATE ADDED	LAST NAME

function gatherWhitelist()
{
	if(isObject(Whitelist_Set))
		for(%i=0;%i<Whitelist_Set.getCount();%i++)
			Whitelist_Set.getObject(%i).delete();
	else
		new SimSet(Whitelist_Set) { };

	%file = new FileObject();
	%file.openForRead($WHITELIST_DB);

	while(!%file.isEOF())
	{
		%line = %file.readLine();
		%data = new ScriptObject(WhitelistData)
		{
			bl_id = getField(%line,0);
			added = getField(%line,1);
			name = getField(%line,2);
		};
		Whitelist_Set.add(%data);
	}

	%file.close();
	%file.delete();
}

function serverCmdAddToWhitelist(%client,%id)
{
	if(!%client.isHost())
		return;

	if(!isObject(Whitelist_Set))
		gatherWhitelist();

	for(%i=0;%i<Whitelist_Set.getCount();%i++)
	{
		%listing = Whitelist_Set.getObject(%i);
		if(%listing.bl_id == %id)
		{
			if(%listing.name $= "")
				%name = "BL_ID" SPC %listing.bl_id;
			else
				%name = %listing.name;

			messageClient(%client,'',"\c3" @ %name SPC "\c0is already whitelisted. \c7(added" SPC %listing.added @ ")");
			return;
		}
	}

	if(findClientNameByBL_ID(%id) !$= "")
		%name = findClientNameByBL_ID(%id);
	else
		%name = "BL_ID" SPC %id;

	%data = new ScriptObject(WhitelistData)
	{
		bl_id = %id;
		added = getDateTime();
		name = findClientNameByBL_ID(%id);
	};
	Whitelist_Set.add(%data);
	messageClient(%client,'',"\c3" @ %name SPC "\c6successfully added to the whitelist.");
	saveWhitelist();
}

function serverCmdRemoveFromWhitelist(%client,%id)
{
	if(!%client.isHost())
		return;

	if(!isObject(Whitelist_Set))
		gatherWhitelist();

	for(%i=0;%i<Whitelist_Set.getCount();%i++)
	{
		%listing = Whitelist_Set.getObject(%i);
		if(%listing.bl_id == %id)
		{
			if(%listing.name $= "")
				%name = "BL_ID" SPC %listing.bl_id;
			else
				%name = %listing.name;

			%listing.delete();

			messageClient(%client,'',"\c3" @ %name SPC "\c6has been removed from the whitelist.");
			saveWhitelist();
			return;
		}
	}

	messageClient(%client,'',"\c3BL_ID" SPC %id SPC "\c0is not whitelisted.");
}

function serverCmdWhitelist(%client)
{
	for(%i=0;%i<Whitelist_Set.getCount();%i++)
	{
		%listing = Whitelist_Set.getObject(%i);
		if(%listing.name !$= "")
			%msg0 = "\c6 --" SPC "\c3" @ %listing.name;

		messageClient(%client,'',"\c2" @ %i+1 @ ".\c6 BL_ID" SPC %listing.bl_id @ %msg0 SPC "\c7(added" SPC %listing.added @ ")");
	}
}

function saveWhitelist()
{
	if(!isObject(Whitelist_Set))
		gatherWhitelist();

	%file = new FileObject();
	%file.openForWrite($WHITELIST_DB);

	for(%i=0;%i<Whitelist_Set.getCount();%i++)
	{
		%listing = Whitelist_Set.getObject(%i);
		%file.writeLine(%listing.bl_id TAB %listing.added TAB %listing.name);
	}

	%file.close();
	%file.delete();
}